
/*
Error ranges :
  0..49      : OK codes
  50..99     : netwib error codes < 255
  100..255   : user error codes < 255
  256..299   : unused
  300..9999  : netwib error codes
  10000..64k : user error codes
So, your own functions can use ranges 100..249 and 10000..64k
*/
#define NETWIB_ERRZONE_OK_BEGIN        0
#define NETWIB_ERRZONE_OK_END         49
#define NETWIB_ERRZONE_NETWIB1_BEGIN   50
#define NETWIB_ERRZONE_NETWIB1_END     99
#define NETWIB_ERRZONE_USER1_BEGIN   100
#define NETWIB_ERRZONE_USER1_END     255
#define NETWIB_ERRZONE_NETWIB2_BEGIN  300
#define NETWIB_ERRZONE_NETWIB2_END   9999
#define NETWIB_ERRZONE_USER2_BEGIN 10000
#define NETWIB_ERRZONE_USER2_END   65535

typedef enum {
#define NETWIB_ERR_OK_BEGIN NETWIB_ERRZONE_OK_BEGIN
  /* normal returns */
  NETWIB_ERR_OK = NETWIB_ERR_OK_BEGIN,
  NETWIB_ERR_OKDATAEND,
  NETWIB_ERR_OKDATANOTAVAIL,
  NETWIB_ERR_OKDATANOSPACE,
  NETWIB_ERR_OKDATAOTHERTYPE,
  NETWIB_ERR_OKNOTFOUND,
  NETWIB_ERR_OKNOTDECODED,
  NETWIB_ERR_OKNOTCONVERTED,
  NETWIB_ERR_OKROUTELOCALDEV,
  NETWIB_ERR_OKROUTENOTFOUND,
  NETWIB_ERR_OKROUTENOTETHER,
  NETWIB__ERR_OK_END,
#define NETWIB_ERR_OK_END NETWIB__ERR_OK_END

#define NETWIB_ERR_FM_BEGIN NETWIB_ERRZONE_NETWIB2_BEGIN
  /* format error (300) */
  NETWIB_ERR_FM = NETWIB_ERR_FM_BEGIN,
  NETWIB_ERR_FMHEXACHAR,
  NETWIB_ERR_FMHEXAODD,
  NETWIB_ERR_FMMIXED,
  NETWIB_ERR_FMBASE64CHAR,
  NETWIB_ERR_FMBASE64X4,
  NETWIB_ERR_FMBASE64LO,
  NETWIB_ERR_FMFMT,
  NETWIB_ERR_FMINT,
  NETWIB__ERR_FM_END,
#define NETWIB_ERR_FM_END NETWIB__ERR_FM_END

#define NETWIB_ERR_PA_BEGIN (NETWIB_ERR_FM_BEGIN+100)
  /* generic parameters errors (400) */
  NETWIB_ERR_PA = NETWIB_ERR_PA_BEGIN,
  NETWIB_ERR_PAINVALIDTYPE,
  NETWIB_ERR_PAINVALIDPOS,
  NETWIB_ERR_PAINVALIDRANGE,
  NETWIB_ERR_PAINVALIDDEFAULT,
  NETWIB_ERR_PANULLPTR,
  NETWIB_ERR_PANULLPTRSIZE,
  NETWIB_ERR_PATOOLOW,
  NETWIB_ERR_PATOOHIGH,
  NETWIB__ERR_PA_END,
#define NETWIB_ERR_PA_END NETWIB__ERR_PA_END

#define NETWIB_ERR_SP_BEGIN (NETWIB_ERR_PA_BEGIN+100)
  /* module specific errors (500) */
  NETWIB_ERR_SP = NETWIB_ERR_SP_BEGIN,
  NETWIB_ERR_SPUNIXSIGHDLBADSIG,
  NETWIB_ERR_SPRINGFULL,
  NETWIB_ERR_SPTLVINVALID,
  NETWIB_ERR_SPTIMEDIFFNEG,
  NETWIB_ERR_SPPATHROOTDOTDOT,
  NETWIB_ERR_SPPATHNOTCLEANED,
  NETWIB_ERR_SPPATHRELATIVE,
  NETWIB_ERR_SPPATHCANTINIT,
  NETWIB_ERR_SPFILE4G,
  NETWIB_ERR_SPFILECHANGED,
  NETWIB_ERR_SPFILESYMLINK,
  NETWIB_ERR_SPFILENOTREG,
  NETWIB_ERR_SPINDEXNODATA,
  NETWIB_ERR_SPTOOBIGFORHDR,
  NETWIB_ERR_SPIP4OPTNOTX4,
  NETWIB_ERR_SPIP4OPTMAX10,
  NETWIB_ERR_SPTCPOPTNOTX4,
  NETWIB_ERR_SPTCPOPTMAX10,
  NETWIB__ERR_SP_END,
#define NETWIB_ERR_SP_END NETWIB__ERR_SP_END

#define NETWIB_ERR_LO_BEGIN (NETWIB_ERR_SP_BEGIN+100)
  /* logic error (600) */
  NETWIB_ERR_LO = NETWIB_ERR_LO_BEGIN,
  NETWIB_ERR_LONOTIMPLEMENTED,
  NETWIB_ERR_LONOTSUPPORTED,
  NETWIB_ERR_LOERRORUNKNOWN,
  NETWIB_ERR_LOERROROKKO,
  NETWIB_ERR_LOOBJINITALREADYINIT,
  NETWIB_ERR_LOOBJUSENOTINITIALIZED,
  NETWIB_ERR_LOOBJUSECLOSED,
  NETWIB_ERR_LOOBJUSECORRUPT,
  NETWIB_ERR_LOOBJCLOSENOTINITIALIZED,
  NETWIB_ERR_LOOBJCLOSEALREADYCLOSED,
  NETWIB_ERR_LOOBJCLOSECORRUPT,
  NETWIB_ERR_LOOBJREADNOTSUPPORTED,
  NETWIB_ERR_LOOBJREADNOTALLOWED,
  NETWIB_ERR_LOOBJWRITENOTSUPPORTED,
  NETWIB_ERR_LOOBJWRITENOTALLOWED,
  NETWIB_ERR_LOOBJRDWRCONFLICT,
  NETWIB_ERR_LOCANTEXEC,
  NETWIB_ERR_LOUDPSERREADBEFWRITE,
  NETWIB__ERR_LO_END,
#define NETWIB_ERR_LO_END NETWIB__ERR_LO_END

#define NETWIB_ERR_IE_BEGIN (NETWIB_ERR_LO_BEGIN+100)
  /* internal errors (700) */
  NETWIB_ERR_IE = NETWIB_ERR_IE_BEGIN,
  NETWIB_ERR_IEINTERNALERROR,
  NETWIB__ERR_IE_END,
#define NETWIB_ERR_IE_END NETWIB__ERR_IE_END

#define NETWIB_ERR_PL_BEGIN (NETWIB_ERR_IE_BEGIN+100)
  /* please errors (800) */
  NETWIB_ERR_PL = NETWIB_ERR_PL_BEGIN,
  NETWIB_ERR_PLTRYNEXT,
  NETWIB_ERR_PLCONSTRUCT,
  NETWIB_ERR_PLLOOPTIME,
  NETWIB__ERR_PL_END,
#define NETWIB_ERR_IE_END NETWIB__ERR_IE_END

#define NETWIB_ERR_FU_BEGIN 1000
  /* system functions errors (1000) */
  NETWIB_ERR_FU = NETWIB_ERR_FU_BEGIN,
  NETWIB_ERR_FUACCEPT,
  NETWIB_ERR_FUBIND,
  NETWIB_ERR_FUCHSIZE,
  NETWIB_ERR_FUCLOCKGETTIME,
  NETWIB_ERR_FUCLOSE,
  NETWIB_ERR_FUCLOSEDIR,
  NETWIB_ERR_FUCLOSEHANDLE,
  NETWIB_ERR_FUCONNECT,
  NETWIB_ERR_FUCREATEEVENT,
  NETWIB_ERR_FUCREATEFILE,
  NETWIB_ERR_FUCREATEMUTEX,
  NETWIB_ERR_FUCREATEPIPE,
  NETWIB_ERR_FUCREATEPROCESS,
  NETWIB_ERR_FUCREATETHREAD,
  NETWIB_ERR_FUDEVICEIOCONTROL,
  NETWIB_ERR_FUDUP2,
  NETWIB_ERR_FUDUPLICATEHANDLE,
  NETWIB_ERR_FUEXECLE,
  NETWIB_ERR_FUEXECVE,
  NETWIB_ERR_FUFCHMOD,
  NETWIB_ERR_FUFCHOWN,
  NETWIB_ERR_FUFCLOSE,
  NETWIB_ERR_FUFCNTL,
  NETWIB_ERR_FUFDOPEN,
  NETWIB_ERR_FUFFLUSH,
  NETWIB_ERR_FUFGETS,
  NETWIB_ERR_FUFILENO,
  NETWIB_ERR_FUFINDCLOSE,
  NETWIB_ERR_FUFINDFIRST,
  NETWIB_ERR_FUFOPEN,
  NETWIB_ERR_FUFORK,
  NETWIB_ERR_FUFREAD,
  NETWIB_ERR_FUFREELIBRARY,
  NETWIB_ERR_FUFSEEK,
  NETWIB_ERR_FUFSTAT,
  NETWIB_ERR_FUFSYNC,
  NETWIB_ERR_FUFTRUNCATE,
  NETWIB_ERR_FUFWRITE,
  NETWIB_ERR_FUGENERATECONSOLECTRLEVENT,
  NETWIB_ERR_FUGETCONSOLEMODE,
  NETWIB_ERR_FUGETEXITCODEPROCESS,
  NETWIB_ERR_FUGETEXITCODETHREAD,
  NETWIB_ERR_FUGETGRGIDR,
  NETWIB_ERR_FUGETGRNAMR,
  NETWIB_ERR_FUGETHOSTNAME,
  NETWIB_ERR_FUGETHOSTBYNAMER,
  NETWIB_ERR_FUGETHOSTBYADDRR,
  NETWIB_ERR_FUGETIFTABLE,
  NETWIB_ERR_FUGETIPADDRTABLE,
  NETWIB_ERR_FUGETIPFORWARDTABLE,
  NETWIB_ERR_FUGETIPNETTABLE,
  NETWIB_ERR_FUGETMSG,
  NETWIB_ERR_FUGETNUMBEROFINTERFACES,
  NETWIB_ERR_FUGETPEERNAME,
  NETWIB_ERR_FUGETPRIORITY,
  NETWIB_ERR_FUGETPROCADDRESS,
  NETWIB_ERR_FUGETPWNAMR,
  NETWIB_ERR_FUGETRLIMIT,
  NETWIB_ERR_FUGETSOCKNAME,
  NETWIB_ERR_FUGETSTDHANDLE,
  NETWIB_ERR_FUGETTHREADPRIORITY,
  NETWIB_ERR_FUGETTIMEOFDAY,
  NETWIB_ERR_FUGLOBALALLOC,
  NETWIB_ERR_FUGLOBALFREE,
  NETWIB_ERR_FULOCALTIMER,
  NETWIB_ERR_FUIOCTL,
  NETWIB_ERR_FUKILL,
  NETWIB_ERR_FULIBNETCLOSELINKINT,
  NETWIB_ERR_FULIBNETCLOSERAWSOCK,
  NETWIB_ERR_FULIBNETGETHWADDR,
  NETWIB_ERR_FULIBNETINIT,
  NETWIB_ERR_FULIBNETOPENLINKINT,
  NETWIB_ERR_FULIBNETOPENRAWSOCK,
  NETWIB_ERR_FULIBNETWRITEIP,
  NETWIB_ERR_FULIBNETWRITELINK,
  NETWIB_ERR_FULIBNETWRITELL,
  NETWIB_ERR_FULIBNETWRITERAWIPV4,
  NETWIB_ERR_FULIBNETWRITERAWIPV6,
  NETWIB_ERR_FULISTEN,
  NETWIB_ERR_FULOADLIBRARY,
  NETWIB_ERR_FULOCALALLOC,
  NETWIB_ERR_FULOCALFREE,
  NETWIB_ERR_FULSEEK,
  NETWIB_ERR_FULSTAT,
  NETWIB_ERR_FUMALLOC,
  NETWIB_ERR_FUMKDIR,
  NETWIB_ERR_FUMPROTECT,
  NETWIB_ERR_FUNANOSLEEP,
  NETWIB_ERR_FUOPEN,
  NETWIB_ERR_FUOPENDIR,
  NETWIB_ERR_FUOPENPROCESS,
  NETWIB_ERR_FUPACKETALLOCATEPACKET,
  NETWIB_ERR_FUPACKETGETADAPTERNAMES,
  NETWIB_ERR_FUPACKETGETNETTYPE,
  NETWIB_ERR_FUPACKETOPENADAPTER,
  NETWIB_ERR_FUPACKETREQUEST,
  NETWIB_ERR_FUPACKETSENDPACKET,
  NETWIB_ERR_FUPACKETSETBUFF,
  NETWIB_ERR_FUPCAPCOMPILE,
  NETWIB_ERR_FUPCAPDUMPOPEN,
  NETWIB_ERR_FUPCAPFINDALLDEVS,
  NETWIB_ERR_FUPCAPGETEVENT,
  NETWIB_ERR_FUPCAPLOOKUPDEV,
  NETWIB_ERR_FUPCAPLOOKUPNET,
  NETWIB_ERR_FUPCAPOPENDEAD,
  NETWIB_ERR_FUPCAPOPENOFFLINE,
  NETWIB_ERR_FUPCAPOPENLIVE,
  NETWIB_ERR_FUPCAPSETFILTER,
  NETWIB_ERR_FUPCLOSE,
  NETWIB_ERR_FUPEEKCONSOLEINPUT,
  NETWIB_ERR_FUPEEKNAMEDPIPE,
  NETWIB_ERR_FUPIPE,
  NETWIB_ERR_FUPOLL,
  NETWIB_ERR_FUPOPEN,
  NETWIB_ERR_FUPTHREADATTRINIT,
  NETWIB_ERR_FUPTHREADATTRDESTROY,
  NETWIB_ERR_FUPTHREADATTRSETATTR,
  NETWIB_ERR_FUPTHREADATTRSETDETACHSTATE,
  NETWIB_ERR_FUPTHREADCONDINIT,
  NETWIB_ERR_FUPTHREADCONDBROADCAST,
  NETWIB_ERR_FUPTHREADCONDDESTROY,
  NETWIB_ERR_FUPTHREADCONDSIGNAL,
  NETWIB_ERR_FUPTHREADCONDTIMEDWAIT,
  NETWIB_ERR_FUPTHREADCONDWAIT,
  NETWIB_ERR_FUPTHREADCREATE,
  NETWIB_ERR_FUPTHREADEXIT,
  NETWIB_ERR_FUPTHREADGETEXPIRATIONNP,
  NETWIB_ERR_FUPTHREADGETSPECIFIC,
  NETWIB_ERR_FUPTHREADJOIN,
  NETWIB_ERR_FUPTHREADKEYCREATE,
  NETWIB_ERR_FUPTHREADKEYDELETE,
  NETWIB_ERR_FUPTHREADMUTEXINIT,
  NETWIB_ERR_FUPTHREADMUTEXDESTROY,
  NETWIB_ERR_FUPTHREADMUTEXLOCK,
  NETWIB_ERR_FUPTHREADMUTEXTIMEDLOCK,
  NETWIB_ERR_FUPTHREADMUTEXTRYLOCK,
  NETWIB_ERR_FUPTHREADMUTEXUNLOCK,
  NETWIB_ERR_FUPTHREADRWLOCKINIT,
  NETWIB_ERR_FUPTHREADRWLOCKDESTROY,
  NETWIB_ERR_FUPTHREADRWLOCKRDLOCK,
  NETWIB_ERR_FUPTHREADRWLOCKWRLOCK,
  NETWIB_ERR_FUPTHREADRWLOCKTIMEDRDLOCK,
  NETWIB_ERR_FUPTHREADRWLOCKTIMEDWRLOCK,
  NETWIB_ERR_FUPTHREADRWLOCKTRYRDLOCK,
  NETWIB_ERR_FUPTHREADRWLOCKTRYWRLOCK,
  NETWIB_ERR_FUPTHREADRWLOCKUNLOCK,
  NETWIB_ERR_FUPTHREADSETSPECIFIC,
  NETWIB_ERR_FUPUTMSG,
  NETWIB_ERR_FURAISE,
  NETWIB_ERR_FUREAD,
  NETWIB_ERR_FUREADFILE,
  NETWIB_ERR_FUREADDIRR,
  NETWIB_ERR_FUREALLOC,
  NETWIB_ERR_FURECV,
  NETWIB_ERR_FURECVFROM,
  NETWIB_ERR_FUREGCLOSEKEY,
  NETWIB_ERR_FUREGCOMP,
  NETWIB_ERR_FUREGENUMKEY,
  NETWIB_ERR_FUREGENUMVALUE,
  NETWIB_ERR_FUREGOPENKEYEX,
  NETWIB_ERR_FUREGQUERYINFOKEY,
  NETWIB_ERR_FUREGQUERYVALUEEX,
  NETWIB_ERR_FURELEASEMUTEX,
  NETWIB_ERR_FURENAME,
  NETWIB_ERR_FURESETEVENT,
  NETWIB_ERR_FURMDIR,
  NETWIB_ERR_FUSELECT,
  NETWIB_ERR_FUSEND,
  NETWIB_ERR_FUSENDTO,
  NETWIB_ERR_FUSETCONSOLEMODE,
  NETWIB_ERR_FUSETEGID,
  NETWIB_ERR_FUSETEUID,
  NETWIB_ERR_FUSETEVENT,
  NETWIB_ERR_FUSETPRIORITY,
  NETWIB_ERR_FUSETSOCKOPT,
  NETWIB_ERR_FUSETSTDHANDLE,
  NETWIB_ERR_FUSETTHREADPRIORITY,
  NETWIB_ERR_FUSIGNAL,
  NETWIB_ERR_FUSNMPEXTENSIONINIT,
  NETWIB_ERR_FUSNMPEXTENSIONQUERY,
  NETWIB_ERR_FUSOCKET,
  NETWIB_ERR_FUSTAT,
  NETWIB_ERR_FUSYMLINK,
  NETWIB_ERR_FUSYSCTL,
  NETWIB_ERR_FUSYSTEM,
  NETWIB_ERR_FUTCGETATTR,
  NETWIB_ERR_FUTCSETATTR,
  NETWIB_ERR_FUTERMINATEPROCESS,
  NETWIB_ERR_FUTERMINATETHREAD,
  NETWIB_ERR_FUTLSALLOC,
  NETWIB_ERR_FUTLSFREE,
  NETWIB_ERR_FUTLSGETVALUE,
  NETWIB_ERR_FUTLSSETVALUE,
  NETWIB_ERR_FUUNLINK,
  NETWIB_ERR_FUVIRTUALALLOC,
  NETWIB_ERR_FUVIRTUALFREE,
  NETWIB_ERR_FUVIRTUALPROTECT,
  NETWIB_ERR_FUWAITFORSINGLEOBJECT,
  NETWIB_ERR_FUWAITPID,
  NETWIB_ERR_FUWRITE,
  NETWIB_ERR_FUWRITEFILE,
  NETWIB_ERR_FUWSACLEANUP,
  NETWIB_ERR_FUWSASTARTUP,
  NETWIB_ERR_FUWSASTARTUPVER,
  NETWIB__ERR_FU_END
#define NETWIB_ERR_FU_END NETWIB__ERR_FU_END

} netwib_err;
